"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSourceLegacy = void 0;
const react_1 = require("react");
const use_subscription_1 = require("use-subscription");
const source_1 = require("../source");
const MissingToken = Symbol();
const useSourceLegacy = (maybeSource, options = {}) => {
    const hasDefaultValue = 'defaultValue' in options;
    const { defaultValue } = options;
    const [core, select] = maybeSource || source_1.nullSource;
    const getCurrentValue = (0, react_1.useCallback)(() => {
        const vector = core[0]();
        return vector.length ? select(vector[0]) : MissingToken;
    }, [core, select]);
    const subscribe = core[1];
    const subscription = (0, react_1.useMemo)(() => ({
        getCurrentValue,
        subscribe,
    }), [getCurrentValue, subscribe]);
    const value = (0, use_subscription_1.useSubscription)(subscription);
    if (value === MissingToken && !hasDefaultValue) {
        throw (0, source_1.getSnapshotPromise)([core, source_1.identitySelector]);
    }
    return value === MissingToken || maybeSource === null ? defaultValue : value;
};
exports.useSourceLegacy = useSourceLegacy;
