"use strict";
/* eslint-disable react-hooks/rules-of-hooks */
/// <reference types="react/experimental" />
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSourceModern = void 0;
const tslib_1 = require("tslib");
const react_1 = (0, tslib_1.__importDefault)(require("react"));
const source_1 = require("../source");
const { useSyncExternalStore } = react_1.default;
const MissingToken = Symbol();
const useSourceModern = (maybeSource, options = {}) => {
    const hasDefaultValue = 'defaultValue' in options;
    const { defaultValue } = options;
    const [core, select] = maybeSource || source_1.nullSource;
    const subscribe = core[1];
    const value = useSyncExternalStore(subscribe, () => {
        const vector = core[0]();
        return vector.length ? select(vector[0]) : MissingToken;
    });
    if (value === MissingToken && !hasDefaultValue) {
        throw (0, source_1.getSnapshotPromise)([core, source_1.identitySelector]);
    }
    return value === MissingToken || maybeSource === null ? defaultValue : value;
};
exports.useSourceModern = useSourceModern;
