/* eslint-disable react-hooks/rules-of-hooks */
/// <reference types="react/experimental" />
import React from 'react';
import { getSnapshotPromise, identitySelector, nullSource, } from '../source';
const { useSyncExternalStore } = React;
const MissingToken = Symbol();
export const useSourceModern = (maybeSource, options = {}) => {
    const hasDefaultValue = 'defaultValue' in options;
    const { defaultValue } = options;
    const [core, select] = maybeSource || nullSource;
    const subscribe = core[1];
    const value = useSyncExternalStore(subscribe, () => {
        const vector = core[0]();
        return vector.length ? select(vector[0]) : MissingToken;
    });
    if (value === MissingToken && !hasDefaultValue) {
        throw getSnapshotPromise([core, identitySelector]);
    }
    return value === MissingToken || maybeSource === null ? defaultValue : value;
};
